game={}
--[[
Online
El cliente siempre sera el player2,
el server el 1
el server administra la velocidad y posicion de la pelota
el cliente envia SOLAMENTE cuando apreta escape y la posicion del coso
]]
function game.load()
	pads={}
	balls={}
	padspeed = 35
	padaccel = 10

	ballhitspeed = 15

	gamesettings={}
	gamesettings.movement=""
	gamesettings.goalsize=""

	--Score
	score1=0
	score2=0

	online=false
	
	updateRate=0.015 --Enviar update cada esto segundos
	updateTimer=0
	enemypause=false

	pause=false
	pausetimer=0
	resendedpause=false

	enemyR=0
	enemyG=0
	enemyB=0
end

function gamestart(data1,data2,internet)
	gamesettings.movement=data1
	gamesettings.goalsize=data2
	createBall()
	gamestate = "game"
	if internet then online = true end

end

function createPad(player,control)
	local pad={}
	if player == 1 then pad.x = 50 end
	if player == 2 then pad.x = 550 end
	pad.y=200-25
	pad.w=15
	pad.h=50
	if player == 1 then pad.xDes = 50 end
	if player == 2 then pad.xDes = 550 end
	pad.yDes=200-25
	pad.control=control
	pad.player=player
	pad.id=#pads
	table.insert(pads,pad)
	return pad.id
end

function createBall()
	local ball={}
	ball.x=300-4
	ball.y=200-4
	ball.w=8
	ball.h=8
	if gamesettings.movement == 1 then
		ball.vx = -ballhitspeed
	else
		ball.vx = 0
	end
	ball.vy=0
	table.insert(balls,ball)
end

function game.keypressed(key)
	if key == "escape" then
		gamestate = "menu"
		menuState = "pausemenu"
		if online then
			pause=true
			updateTimer = 0
			connection:send("pause/".."true".."/")
		end
	end
end

function game.update(dt)
	if enemypause then return end
	--Online
	updateTimer=updateTimer+dt
	if updateTimer >= updateRate then
		onlineUpdate(dt)
		updateTimer = 0
	end
	--Control
	for i,v in ipairs(pads) do
		if v.control == "Mouse" then
			local mx,my = love.mouse.getPosition(); mx = mx / scale; my = my / scale
			local xspeed=(mx-(v.w/2)) - v.x
			local yspeed=(my-(v.h/2)) - v.y
			--Limite de velocidad
			if xspeed > padspeed then xspeed = padspeed end
			if xspeed < -padspeed then xspeed = -padspeed end
			if yspeed > padspeed then yspeed = padspeed end
			if yspeed < -padspeed then yspeed = -padspeed end

			v.x=v.x + ((xspeed)*dt * 10)
			v.y=v.y + ((yspeed)*dt * 10)
		elseif v.control == "Keyboard" then
			v.x = v.x + ((v.xDes - v.x)*dt * padaccel)
			v.y = v.y + ((v.yDes - v.y)*dt * padaccel)
			if love.keyboard.isDown("left") then
				v.xDes = v.xDes - (padspeed * dt) * 10
			elseif love.keyboard.isDown("right") then
				v.xDes = v.xDes + (padspeed * dt) * 10
			end
			if love.keyboard.isDown("up") then
				v.yDes = v.yDes - (padspeed * dt) * 10
			elseif love.keyboard.isDown("down") then
				v.yDes = v.yDes + (padspeed * dt) * 10
			end
		end
		--Limite de pantalla
		if gamesettings.movement == 3 then
			if v.x < 0 then v.x = 0; v.xDes = 0 end
			if v.x > 600-v.w then v.x = 600-v.w; v.xDes = 600-v.w end
			if v.y < 0 then v.y = 0; v.yDes = 0 end
			if v.y > 400-v.h then v.y = 400-v.h; v.yDes = 400-v.h end
		elseif gamesettings.movement == 2 then
			if v.player == 1 then
				if v.x < 0 then v.x = 0; v.xDes = 0 end
				if v.x > 300-v.w then v.x = 300-v.w; v.xDes = 300-v.w end
				if v.y < 0 then v.y = 0; v.yDes = 0 end
				if v.y > 400-v.h then v.y = 400-v.h; v.yDes = 400-v.h end
			elseif v.player == 2 then
				if v.x < 300 then v.x = 300; v.xDes = 300 end
				if v.x > 600-v.w then v.x = 600-v.w; v.xDes = 600-v.w end
				if v.y < 0 then v.y = 0; v.yDes = 0 end
				if v.y > 400-v.h then v.y = 400-v.h; v.yDes = 400-v.h end
			end
		elseif gamesettings.movement == 1 then
			if v.player == 1 then
				v.x = 50 - v.w / 2
				v.xDes = 50 - v.w / 2
				if v.y < 0 then v.y = 0; v.yDes = 0 end
				if v.y > 400-v.h then v.y = 400-v.h; v.yDes = 400-v.h end
			elseif v.player == 2 then
				v.x = 550 - v.w / 2
				v.xDes = 550 - v.w / 2
				if v.y < 0 then v.y = 0; v.yDes = 0 end
				if v.y > 400-v.h then v.y = 400-v.h; v.yDes = 400-v.h end
			end
		end
	end
	--Pelota (parte dificil :c)
	for i,v in ipairs(balls) do
		for ii,vv in ipairs(pads) do
			local col,colside = checkCollision(vv.x,vv.y,vv.w,vv.h,v.x,v.y,v.w,v.h)
			v.x=v.x+v.vx *dt * 10
			v.y=v.y+v.vy *dt * 10
			if col then
				if colside == "left" then
					v.x = vv.x + vv.w + 5
					v.vx = ballhitspeed
					v.vy = v.vy + ((v.y+v.h/2)-(vv.y+vv.h/2))*0.25
				end
				if colside == "right" then
					v.x = vv.x - v.w - 5
					v.vx = -ballhitspeed
					v.vy = v.vy + ((v.y+v.h/2)-(vv.y+vv.h/2))*0.25
				end
				if colside == "up" then
					v.y = vv.y + vv.h + 5
					v.vy = ballhitspeed
				end
				if colside == "down" then
					v.y = vv.y - v.h - 5
					v.vy = -ballhitspeed
				end
			end
			if v.y < 0 then
				v.y = 0
				v.vy = -v.vy
			elseif v.y > 400 - v.h then
				v.y = 400 - v.h
				v.vy = -v.vy
			end
			--Goles!
			if v.x < 0 then
				if gamesettings.goalsize == 1 then
					v.x = 300 - v.w/2
					v.y = 200 - v.h/2
					v.vx,v.vy = -ballhitspeed,0
					score2=score2+1
				elseif gamesettings.goalsize == 2 then
					if v.y > 100 and v.y < 300 - v.h then
						v.x = 300 - v.w/2
						v.y = 200 - v.h/2
						v.vx,v.vy = -ballhitspeed,0
						score2=score2+1
					else
						v.x = 0
						v.vx = ballhitspeed
					end
				elseif gamesettings.goalsize == 3 then
					if v.y > 150 and v.y < 250 - v.h then
						v.x = 300 - v.w/2
						v.y = 200 - v.h/2
						v.vx,v.vy = -ballhitspeed,0
						score2=score2+1
					else
						v.x = 0
						v.vx = ballhitspeed
					end
				end
			elseif v.x > 600 - v.w then
				if gamesettings.goalsize == 1 then
					v.x = 300 - v.w/2
					v.y = 200 - v.h/2
					v.vx,v.vy = ballhitspeed,0
					score1=score1+1
				elseif gamesettings.goalsize == 2 then
					if v.y > 100 and v.y < 300 - v.h then
						v.x = 300 - v.w/2
						v.y = 200 - v.h/2
						v.vx,v.vy = ballhitspeed,0
						score1=score1+1
					else
						v.x = 600 - v.w
						v.vx = -ballhitspeed
					end
				elseif gamesettings.goalsize == 3 then
					if v.y > 150 and v.y < 250 - v.h then
						v.x = 300 - v.w/2
						v.y = 200 - v.h/2
						v.vx,v.vy = ballhitspeed,0
						score1=score1+1
					else
						v.x = 600 - v.w
						v.vx = -ballhitspeed
					end
				end
			end
		end
	end
end

function game.draw()
	love.graphics.line(300,0,300,400)
	for i,v in ipairs(pads) do
		if not online then
			if v.player == 1 then love.graphics.setColor(playerColor.f.R,playerColor.f.G,playerColor.f.B,255) end
			if v.player == 2 then love.graphics.setColor(playerColor.s.R,playerColor.s.G,playerColor.s.B,255) end
			love.graphics.rectangle("fill",v.x,v.y,v.w,v.h)
			love.graphics.setColor(255,255,255,255)
		elseif client then
			if v.player == 1 then love.graphics.setColor(enemyR,enemyG,enemyB,255) end
			if v.player == 2 then love.graphics.setColor(playerColor.f.R,playerColor.f.G,playerColor.f.B,255) end
			love.graphics.rectangle("fill",v.x,v.y,v.w,v.h)
			love.graphics.setColor(255,255,255,255)
		elseif server then
			if v.player == 1 then love.graphics.setColor(playerColor.f.R,playerColor.f.G,playerColor.f.B,255) end
			if v.player == 2 then love.graphics.setColor(enemyR,enemyG,enemyB,255) end
			love.graphics.rectangle("fill",v.x,v.y,v.w,v.h)
			love.graphics.setColor(255,255,255,255)
		end
		--Escribir posicion
		love.graphics.print(v.player.." ".."x:"..math.floor(v.x).." y:"..math.floor(v.y),0,16*i-16)
	end
	for i,v in ipairs(balls) do
		love.graphics.rectangle("fill",v.x,v.y,v.w,v.h)
	end
	--Score!
	love.graphics.setFont(square)
	love.graphics.printf(score1,0,50,290,"right")
	love.graphics.printf(score2,310,50,290,"left")
	love.graphics.setFont(squaresmall)
	if gamesettings.goalsize == 2 then
		love.graphics.line(1,0,1,100)
		love.graphics.line(1,300,1,400)
		love.graphics.line(599,0,599,100)
		love.graphics.line(599,300,599,400)
	elseif gamesettings.goalsize == 3 then
		love.graphics.line(1,0,1,150)
		love.graphics.line(1,250,1,400)
		love.graphics.line(599,0,599,150)
		love.graphics.line(599,250,599,400)
	end
	if enemypause then
		love.graphics.setFont(square)
		love.graphics.setColor(255,255,255,150)
		love.graphics.printf("PAUSED",0,200-15,600,"center")
		love.graphics.setColor(255,255,255,255)
		love.graphics.setFont(squaresmall)
	end
end

function stopGame()
	pads=nil
	balls=nil
	pads={}
	balls={}
	score1=0
	score2=0
	gamestate = "menu"
	menuState = "mainmenu"
end

--Checkeo de colision para toda la vida
function checkCollision(x1,y1,w1,h1,x2,y2,w2,h2)
	local side="none"
	local check1 = x1 + w1 - x2
	local check2 = y1 + h1 - y2
	local check3 = x2 + w2 - x1
	local check4 = y2 + h2 - y1
	if (check1 > 0 and check2 > 0 and check3 > 0 and check4 > 0) then
		if (check1 < check2 and check1 < check3 and check1 < check4) then
			side = "left"
		elseif (check2 < check1 and check2 < check3 and check2 < check4) then
			side = "up"
		elseif (check3 < check1 and check3 < check2 and check3 < check4) then
			side = "right"
		elseif (check4 < check1 and check4 < check2 and check4 < check3) then
			side = "down"
		end
		return true,side
	else
		return false
	end
end

function onlineUpdate(dt)
	if client then
		--Enviar pad del cliente al server
		for i,v in ipairs(pads) do
			if v.player == 2 then
				connection:send("clientpos/"..v.x.."/"..v.y.."/")
			end
		end
	elseif server then
		--Enviar pad server al cliente y la posicion de la pelota
		for i,v in ipairs(pads) do
		for _,ball in ipairs(balls) do
			if v.player == 1 then
				connection:send("serverdata/"..v.x.."/"..v.y.."/"..ball.x.."/"..ball.y.."/"..ball.vx.."/"..ball.vy.."/"..score1.."/"..score2.."/")
			end
		end
		end
	end
end