menu={}
function menu.load()
	square = love.graphics.newFont( "Square.ttf", 30 )	--Cargar nueva fuente
	squaresmall = love.graphics.newFont( "Square.ttf", 15 )	--Cargar nueva fuente
	menuState="mainmenu"

	--Chat
	chat={}
	chat.enabled=false
	chat.x=20
	chat.y=40
	chat.w=560
	chat.h=145
	chat.writing=false
	chat.text=""

	--Textos en el chat
	chattext={}

	--Graficos
	width, height, fullscreen, vsync, fsaa = love.graphics.getMode()
	scale=1
	maxScale=2
	maxFSAA=8

	--Titulo
	title={}
	title.enabled=true
	title.image=love.graphics.newImage("gfx/pong.png")
	title.x=300
	title.y=100
	title.rot=0
	title.rotDes=math.rad(30)
	title.rotTimer=0
	title.rotMaxTimer=1	--Segundos

	--Control
	player1control="Mouse"
	player2control="Keyboard"
	localPlayerControl="Mouse"

	--Opciones custom
	movement={}
	movement.list={"Vertical only","Free on side","Free"}
	movement.selected=1
	goalsize={}
	goalsize.list={"Full","Half","1/4"}
	goalsize.selected=1

	--Online
	onlinemenu={}
	onlinemenu.port=27015
	onlinemenu.host=false
	onlinemenu.ip={190,047,087,103}
	onlinemenu.selectedip=0
	onlinemenu.changingip=false

	--Menus
	items={}
	items.mainmenu={"Game","Settings","Exit"}
	items.gamemenu={"Local","Online"}
	items.settingsmenu={"Graphics","Player"}
	items.graphicsmenu={"Scale:"..scale,"VSYNC:".."none","Fullscreen:".."none","FSAA:".."none"}
	items.playermenu={"Player 1","Player 2"}
	items.playerconfigmenu={"R:              ","G:              ","B:              "}
	items.localmenu={"Start","Custom","Controls"}
	items.controlmenu={"Player 1:"..player1control,"Player 2:"..player2control}
	items.custommenu={"Movement:".."none","Goal size:".."none"}
	items.onlinemenu={"Join","Host"}
	items.portmenu={"Port:"..onlinemenu.port,"Start Server"}
	items.hostmenu={"Start","Custom","Control:".."none"}
	items.connectmenu={"IP:"..onlinemenu.ip[1].."."..onlinemenu.ip[2].."."..onlinemenu.ip[3].."."..onlinemenu.ip[4],"Port:"..onlinemenu.port,"Connect"}
	items.clientmenu={"Waiting for host","Control:".."none","Disconnect"}
	items.pausemenu={"Continue","Exit"}

	--Player menu
	playermenu={}
	playermenu.playerSelected=0
	playermenu.R=255
	playermenu.G=255
	playermenu.B=255

	--Cantidad y nombre de items
	itemCounter=0
	itemText=""

	--Cursor
	cursor={}
	cursor.x=0
	cursor.xDes=0
	cursor.y=0
	cursor.yDes=0
	cursor.w=0
	cursor.wDes=0
	cursor.h=34
	cursor.currentPos=1
end

function menu.keypressed(key)
	--Chat
	if chat.writing then
		if key == "backspace" then
			if chat.text == "> " then return end
			chat.text=string.sub(chat.text, 1, #chat.text-1)
		end
		if string.len(key) == 1 then
			if string.len(chat.text) > 54 then return end
			chat.text = chat.text .. key
		end
		if key == "return" then
			local type=""
			if client then type = "Client" else type = "Server" end
			chat.text=type..":"..string.sub(chat.text,3,#chat.text)
			printc(chat.text,true)
			chat.text = ""
			chat.writing = false
		end
		return
	end
	if menuState == "hostmenu" or menuState == "clientmenu" then
		if key == "t" then
			if chat.writing == false then
				chat.writing=true
				chat.text="> "
			end
		end
	end
	if chat.writing then return end

	if menuState == "portmenu" and cursor.currentPos == 1 or menuState == "connectmenu" and cursor.currentPos == 2 then
		if key == "right" then onlinemenu.port = onlinemenu.port + 1 end
		if key == "left" then onlinemenu.port = onlinemenu.port - 1 end
	end
	if menuState == "connectmenu" then
		if onlinemenu.changingip then
			if key == "right" then
				onlinemenu.ip[onlinemenu.selectedip]=onlinemenu.ip[onlinemenu.selectedip]+1
			elseif key == "left" then
				onlinemenu.ip[onlinemenu.selectedip]=onlinemenu.ip[onlinemenu.selectedip]-1
			end
		end
	end
	if key == "down" then
		cursor.currentPos = cursor.currentPos + 1
		if cursor.currentPos > itemCounter then
			cursor.currentPos = itemCounter
		end
	elseif key == "up" then
		cursor.currentPos = cursor.currentPos - 1
		if cursor.currentPos < 1 then
			cursor.currentPos = 1
		end
	elseif key == "return" then
		--Menu principal
		if itemText == "Game" then menuState = "gamemenu"; cursor.currentPos=1 return end
		if itemText == "Settings" then menuState = "settingsmenu"; cursor.currentPos=1 return end
		if itemText == "Exit" and menuState == "mainmenu" then quit() end
		--Local menu
		if itemText == "Local" then menuState = "localmenu"; cursor.currentPos=1 return end
		if itemText == "Controls" then menuState = "controlmenu"; cursor.currentPos=1 return end
		if menuState == "localmenu" and itemText == "Start" then
			createPad(1,player1control)
			createPad(2,player2control)
			gamestart(movement.selected,goalsize.selected)
		end
		--Pause menu
		if itemText == "Continue" then gamestate = "game"; pause = false;unPause() ; cursor.currentPos=1 return end
		if itemText == "Exit" and client then stopGame(); disconnectClient(); cursor.currentPos=1 return end
		if itemText == "Exit" and server then stopGame(); stopGameServer(); cursor.currentPos=1 return end
		if itemText == "Exit" then stopGame(); cursor.currentPos=1 return end
		--Online menu
		if itemText == "Online" and server then menuState = "hostmenu"; cursor.currentPos=1; allowConnection=true return end
		if itemText == "Online" then menuState = "onlinemenu"; cursor.currentPos=1 return end
		--Menu settings
		if itemText == "Graphics" then menuState = "graphicsmenu"; cursor.currentPos=1 return end
		if itemText == "Player" then menuState = "playermenu"; cursor.currentPos=1 return end
		--Online
		if itemText == "Host" then menuState = "portmenu"; cursor.currentPos=1 return end
		if itemText == "Join" then menuState = "connectmenu"; cursor.currentPos=1 return end
		if itemText == "Connect" then clientConnect(onlinemenu.ip[1].."."..onlinemenu.ip[2].."."..onlinemenu.ip[3].."."..onlinemenu.ip[4],onlinemenu.port) return end
		if itemText == "Disconnect" then menuState = "onlinemenu"; cursor.currentPos=1; disconnectClient() return end
		if menuState == "connectmenu" and cursor.currentPos == 1 then
			onlinemenu.changingip = true
			onlinemenu.selectedip = onlinemenu.selectedip + 1
			if onlinemenu.selectedip > 4 then
				onlinemenu.selectedip = 0
				onlinemenu.changingip = false
			end
		end
		--Controles online
		if menuState == "clientmenu" and cursor.currentPos == 2 then
			if localPlayerControl == "Mouse" then localPlayerControl = "Keyboard" return end
			if localPlayerControl == "Keyboard" then localPlayerControl = "Mouse" return end
		end
		if menuState == "hostmenu" and cursor.currentPos == 3 then
			if localPlayerControl == "Mouse" then localPlayerControl = "Keyboard" return end
			if localPlayerControl == "Keyboard" then localPlayerControl = "Mouse" return end
		end
		--Controlmenu
		if menuState == "controlmenu" then
			if cursor.currentPos == 1 then
				if player1control == "Mouse" then player1control = "Keyboard"; player2control = "Mouse" return end
				if player1control == "Keyboard" then player1control = "Mouse"; player2control = "Keyboard" return end
			elseif cursor.currentPos == 2 then
				if player2control == "Mouse" then player2control = "Keyboard"; player1control = "Mouse" return end
				if player2control == "Keyboard" then player2control = "Mouse"; player1control = "Keyboard" return end
			end
		end
		if menuState == "hostmenu" and itemText == "Start" then --Cuando el host aprete start
			--Si no ai cliente no hacer nada
			if not foundClient then return end
			--Avisarle al cliente
			connection:send("start/"..movement.selected.."/"..goalsize.selected)
			--Iniciar el juego
			gamestart(movement.selected,goalsize.selected,true)
			createPad(1,localPlayerControl)
			createPad(2,online)
		end
		if menuState == "portmenu" then
			if cursor.currentPos == 2 then menuState = "hostmenu"; cursor.currentPos=1; createServer(onlinemenu.port); onlinemenu.host = true return end
		end
		--Custom
		if itemText == "Custom" then menuState = "custommenu"; cursor.currentPos=1 return end
		if menuState == "custommenu" then
			if cursor.currentPos == 1 then
				movement.selected = movement.selected + 1
				if movement.selected > #movement.list then
					movement.selected = 1
				end
				return
			elseif cursor.currentPos == 2 then
				goalsize.selected = goalsize.selected +1
				if goalsize.selected > #goalsize.list then
					goalsize.selected = 1
				end
				return
			end
		end
		--Player menu
		if itemText == "Player" then menuState = "playermenu"; cursor.currentPos=1 return end
		if itemText == "Player 1" then
			playermenu.playerSelected = 1
			menuState = "playerconfigmenu"
			playermenu.R=playerColor.f.R
			playermenu.G=playerColor.f.G
			playermenu.B=playerColor.f.B
			cursor.currentPos=1
			return 
		end
		if itemText == "Player 2" then
			playermenu.playerSelected = 2
			menuState = "playerconfigmenu"
			playermenu.R=playerColor.s.R
			playermenu.G=playerColor.s.G
			playermenu.B=playerColor.s.B
			cursor.currentPos=1
			return
		end
		--Graphics
		if menuState == "graphicsmenu" then
			--VSYNC
			if itemText == "VSYNC:true" then
				love.graphics.setMode( width, height, fullscreen, false, fsaa )
				return
			elseif itemText == "VSYNC:false" then
				love.graphics.setMode( width, height, fullscreen, true, fsaa )
				return
			end
			--Scale
			if cursor.currentPos == 1 then
				scale = scale + 0.2
				if scale > maxScale then
					scale = 1
				end
				love.graphics.setMode( 600*scale, 400*scale, fullscreen, vsync, fsaa )
				return
			end
			--Fullscreen
			if itemText == "Fullscreen:true" then
				love.graphics.setMode( width, height, false, vsync, fsaa )
				return
			elseif itemText == "Fullscreen:false" then
				love.graphics.setMode( width, height, true, vsync, fsaa )
				return
			end
			--FSAA
			if cursor.currentPos == 4 then
				if fsaa * 2 > maxFSAA then
					love.graphics.setMode( width, height, fullscreen, vsync, 0 )
				elseif fsaa == 0 then
					love.graphics.setMode( width, height, fullscreen, vsync, 2 )
				else
					love.graphics.setMode( width, height, fullscreen, vsync, fsaa * 2 )
				end
				return
			end
		end
	elseif key == "escape" then
		if menuState == "gamemenu" or menuState == "settingsmenu" then menuState = "mainmenu"; cursor.currentPos=1 end
		if menuState == "localmenu" or menuState == "onlinemenu" then menuState = "gamemenu"; cursor.currentPos=1 end
		if menuState == "graphicsmenu" then menuState = "settingsmenu"; cursor.currentPos=1; saveVideoSettings() end
		if menuState == "playermenu" then menuState = "settingsmenu"; cursor.currentPos=1 end
		if menuState == "controlmenu" then menuState = "localmenu"; cursor.currentPos=1 end
		if menuState == "connectmenu" then menuState = "onlinemenu"; cursor.currentPos=1; onlinemenu.changingip = false; onlinemenu.selectedip = 0 end
		if menuState == "custommenu" then
			if onlinemenu.host then
				menuState = "hostmenu"
			else
				menuState = "localmenu"
			end
			cursor.currentPos=1
		end
		if menuState == "portmenu" then menuState = "onlinemenu"; cursor.currentPos=1 end
		if menuState == "playerconfigmenu" then
			savePlayerSettings(playermenu.playerSelected,playermenu.R,playermenu.G,playermenu.B)
			menuState = "playermenu"
			cursor.currentPos=1
			playermenu.R=255
			playermenu.G=255
			playermenu.B=255
		end
	end
end

function menu.update(dt)
	--Reenviar pausa en caso de
	if pause then
		pausetimer = pausetimer + dt
		if pausetimer >= 0.5 and resendedpause == false then
			connection:send("pause/".."true".."/")
			resendedpause = true
		end
	end
	--Chat
	if menuState == "hostmenu" or menuState == "clientmenu" or menuState == "connectmenu" then
		showChat(true)
	else
		showChat(false)
	end
	--Limites de cambiar puerto
	for i=1,4 do
		if onlinemenu.ip[i] < 0 then
			onlinemenu.ip[i] = 255
		elseif onlinemenu.ip[i] > 255 then
			onlinemenu.ip[i] = 0
		end
	end
	--Cambiar puerto en host
	if menuState == "portmenu" and cursor.currentPos == 1 or (menuState == "connectmenu" and cursor.currentPos==2) then
		if love.keyboard.isDown("lshift") then
			if love.keyboard.isDown("right") then
				onlinemenu.port = onlinemenu.port + 10
			elseif love.keyboard.isDown("left") then
				onlinemenu.port = onlinemenu.port - 10
			end
		end
	end
	if menuState == "connectmenu" and onlinemenu.changingip then
		if love.keyboard.isDown("lshift") then
			if love.keyboard.isDown("right") then
				onlinemenu.ip[onlinemenu.selectedip]=onlinemenu.ip[onlinemenu.selectedip]+5
			elseif love.keyboard.isDown("left") then
				onlinemenu.ip[onlinemenu.selectedip]=onlinemenu.ip[onlinemenu.selectedip]-5
			end
		end
	end
	--Actualizar posicion y tamanio del cursor
	if itemCounter <= 4 then
		cursor.x=300-(cursor.w/2)
		cursor.y=cursor.y + ((cursor.yDes - cursor.y)*dt * 10)
		cursor.yDes=200+(cursor.currentPos*32)
	else
		if cursor.currentPos <= 4 then
			cursor.x=cursor.x + ((cursor.xDes - cursor.x)*dt * 10)
			cursor.xDes=150-(cursor.w/2)
			cursor.y=cursor.y + ((cursor.yDes - cursor.y)*dt * 10)
			cursor.yDes=200+(cursor.currentPos*32)
		else
			cursor.x=cursor.x + ((cursor.xDes - cursor.x)*dt * 10)
			cursor.xDes=450-(cursor.w/2)
			cursor.y=cursor.y + ((cursor.yDes - cursor.y)*dt * 10)
			cursor.yDes=200+(cursor.currentPos*32)-(32*4)
		end
	end

	--Ancho del cursor es la cantidad de caracteres del texto * 20
	cursor.w = cursor.w + ((cursor.wDes - cursor.w)*dt * 10)
	cursor.wDes = string.len(itemText) * 20

	--Rotacion del titulo
	title.rot = title.rot + ((title.rotDes - title.rot)*dt*2.5)

	--Timer del titulo
	title.rotTimer = title.rotTimer + dt
	if title.rotTimer >= title.rotMaxTimer then
		title.rotTimer = 0
		title.rotDes = -title.rotDes
	end

	--Actualizar informacion graphicsmenu
	if menuState == "graphicsmenu" then
		width, height, fullscreen, vsync, fsaa = love.graphics.getMode()
		items.graphicsmenu[1]="Scale:"..scale
		items.graphicsmenu[2]="VSYNC:"..tostring(vsync)
		items.graphicsmenu[3]="Fullscreen:"..tostring(fullscreen)
		items.graphicsmenu[4]="FSAA:"..fsaa
	end

	--Sliders playerconfig menu
	if menuState == "playerconfigmenu" then
		if cursor.currentPos == 1 then
			if love.keyboard.isDown("left") then
				playermenu.R=playermenu.R-(100*dt)
			elseif love.keyboard.isDown("right") then
				playermenu.R=playermenu.R+(100*dt)
			end
			if playermenu.R > 255 then playermenu.R = 255 end
			if playermenu.R < 10 then playermenu.R = 10 end
		elseif cursor.currentPos == 2 then
			if love.keyboard.isDown("left") then
				playermenu.G=playermenu.G-(100*dt)
			elseif love.keyboard.isDown("right") then
				playermenu.G=playermenu.G+(100*dt)
			end
			if playermenu.G > 255 then playermenu.G = 255 end
			if playermenu.G < 10 then playermenu.G = 10 end
		elseif cursor.currentPos == 3 then
			if love.keyboard.isDown("left") then
				playermenu.B=playermenu.B-(100*dt)
			elseif love.keyboard.isDown("right") then
				playermenu.B=playermenu.B+(100*dt)
			end
			if playermenu.B > 255 then playermenu.B = 255 end
			if playermenu.B < 10 then playermenu.B = 10 end
		end
	end
	--Actualizar opciones menu custom
	items.custommenu[1] = "Movement:"..movement.list[movement.selected]
	items.custommenu[2] = "Goal size:"..goalsize.list[goalsize.selected]
	--Actualizar puerto
	if onlinemenu.port < 0 then
		onlinemenu.port = 1
	elseif onlinemenu.port > 30000 then
		onlinemenu.port = 30000
	end
	items.portmenu[1] = "Port:"..onlinemenu.port
	items.connectmenu[2] = "Port:"..onlinemenu.port
	--Actualizar ip
	if onlinemenu.selectedip == 1 then
		items.connectmenu[1] = "IP:".."-"..onlinemenu.ip[1].."-".."."..onlinemenu.ip[2].."."..onlinemenu.ip[3].."."..onlinemenu.ip[4],"Port:"..onlinemenu.port
	elseif onlinemenu.selectedip == 2 then
		items.connectmenu[1] = "IP:"..onlinemenu.ip[1]..".".."-"..onlinemenu.ip[2].."-".."."..onlinemenu.ip[3].."."..onlinemenu.ip[4],"Port:"..onlinemenu.port
	elseif onlinemenu.selectedip == 3 then
		items.connectmenu[1] = "IP:"..onlinemenu.ip[1].."."..onlinemenu.ip[2]..".".."-"..onlinemenu.ip[3].."-".."."..onlinemenu.ip[4],"Port:"..onlinemenu.port
	elseif onlinemenu.selectedip == 4 then
		items.connectmenu[1] = "IP:"..onlinemenu.ip[1].."."..onlinemenu.ip[2].."."..onlinemenu.ip[3]..".".."-"..onlinemenu.ip[4].."-","Port:"..onlinemenu.port
	else
		items.connectmenu[1] = "IP:"..onlinemenu.ip[1].."."..onlinemenu.ip[2].."."..onlinemenu.ip[3].."."..onlinemenu.ip[4]
	end
	--Actualizar controlmenu
	items.controlmenu[1]="Player 1:"..player1control
	items.controlmenu[2]="Player 2:"..player2control
	--y el control en el cliente y host
	items.clientmenu[2]="Control:"..localPlayerControl
	items.hostmenu[3]="Control:"..localPlayerControl
	--Forzar terminar de poner ip antes de moverse
	if onlinemenu.changingip then cursor.currentPos = 1 end
end

function menu.draw()
	love.graphics.setFont(square) --Poner la fuente
	--Dibujar textos
	love.graphics.setColor(255,255,255,155)
	for subTi,subT in pairs(items) do
		for i,text in pairs(subT) do
			if subTi == menuState then
				itemCounter=#subT
				if itemCounter <= 4 then
					if menuState == "playerconfigmenu" then
						love.graphics.printf(text,cursor.x+5,200+(i*32),cursor.w,"left")
					else
						love.graphics.printf(text,0,200+(i*32),600,"center")
					end
				else
					if i <= 4 then
						love.graphics.printf(text,0,200+(i*32),300,"center")
					else
						love.graphics.printf(text,300,200+((i*32)-(4*32)),300,"center")
					end
				end
				if i == cursor.currentPos then
					itemText = text
				end
			end
		end
	end
	love.graphics.setColor(255,255,255,255)
	--Dibujar cursor
	love.graphics.rectangle("line",cursor.x,cursor.y,cursor.w,cursor.h)
	--Titulo y chat
	if title.enabled then
		love.graphics.setColor(playermenu.R,playermenu.G,playermenu.B,255)
		love.graphics.draw(title.image,title.x,title.y,title.rot,1,1,title.image:getWidth()/2,title.image:getHeight()/2)
		love.graphics.setColor(255,255,255,255)
	elseif chat.enabled then
		love.graphics.setFont(squaresmall)
		love.graphics.printf(chat.text,chat.x+2,chat.y-15,chat.w,"left")
		love.graphics.rectangle("line",chat.x,chat.y,chat.w,chat.h)
		--Textos del chat
		for i,v in ipairs(chattext) do
			love.graphics.printf(v.string,chat.x+2,chat.y+(16*i)-16,chat.w,"left")
			if i > 9 then
				table.remove(chattext,1)
			end
		end
	end
	love.graphics.setFont(square)
	--FPS
	love.graphics.print("FPS:"..love.timer.getFPS(),0,365)
	--Menu player config
	if menuState == "playerconfigmenu" then
		love.graphics.setColor(255,255,255,100)
		love.graphics.printf("Player " .. playermenu.playerSelected .. " color",0,200,600,"center")
		love.graphics.setColor(255,255,255,255)
		for i=1,3 do
			local progress=0
			if i == 1 then progress = playermenu.R; love.graphics.setColor(255,0,0,100) end
			if i == 2 then progress = playermenu.G; love.graphics.setColor(0,255,0,100) end
			if i == 3 then progress = playermenu.B; love.graphics.setColor(0,0,255,100) end
			love.graphics.rectangle("fill",cursor.x+55,210+(i*32),progress,cursor.h-20)
			love.graphics.setColor(255,255,255,255)
		end
	elseif menuState == "portmenu" or menuState == "connectmenu" then
		love.graphics.setColor(255,255,255,100)
		love.graphics.printf("Press SHIFT to go faster",0,365,600,"right")
		love.graphics.setColor(255,255,255,255)
	elseif menuState == "mainmenu" then
		love.graphics.setColor(255,255,255,100)
		love.graphics.printf("v"..version,0,365,600,"right")
		love.graphics.setColor(255,255,255,255)
	elseif menuState == "hostmenu" then
		if foundClient == false then
			love.graphics.setColor(255,255,255,100)
			love.graphics.printf("Waiting for client",0,365,600,"right")
			love.graphics.setColor(255,255,255,255)
		end
	end
end

function quit()
	love.event.quit()
end

function showChat(condition)
	if condition then
		chat.enabled = true
		title.enabled = false
	else
		chat.enabled = false
		title.enabled = true
	end
end

function printc(data,chat)
	local text={}
	text.string=data
	table.insert(chattext,text)
	--Hacer lo mismo al otro lado
	if chat then connection:send("chat/"..data) end
end

function unPause()
	if server or client then
		pause=false
		pausetimer=0
		resendedpause=false
		connection:send("pause/false/")
	end
end