save={}
function save.load()
	love.filesystem.setIdentity("pong2")
	--Configuracion de video
	if love.filesystem.isFile( "video.txt" ) then
		loadVideoSettings()
	else
		love.filesystem.newFile("video.txt")
		love.graphics.setMode( 600, 400, false, false, 0 )
		love.filesystem.write("video.txt", 1 ..":".. tostring(false) .. ":" .. tostring(false) ..":" .. 0, 50 )
		if love.filesystem.isFile( "video.txt" ) then
			print("Created video settings.")
		else
			print("Error creating video settings.")
		end
	end
	--Configuracion de color
	playerColor={}
	playerColor.f={}
	playerColor.f.R=255
	playerColor.f.G=255
	playerColor.f.B=255
	playerColor.s={}
	playerColor.s.R=255
	playerColor.s.G=255
	playerColor.s.B=255

	--Colores
	if love.filesystem.isFile( "player.txt" ) then
		loadPlayerSettings()
	else
		love.filesystem.newFile("player.txt")
		love.filesystem.write("player.txt", "255:255:255:255:255:255",150)
		if love.filesystem.isFile( "player.txt" ) then
			print("Created player settings.")
		else
			print("Error creating player settings.")
		end
	end
end

function saveVideoSettings()
	if love.filesystem.isFile( "video.txt" ) then
		love.filesystem.write("video.txt", scale..":"..tostring(vsync)..":"..tostring(fullscreen)..":"..fsaa, 50 )
		print("Saved video settings.")
	else
		print("Video settings file not found.")
	end
end

function loadVideoSettings()
	if love.filesystem.isFile( "video.txt" ) then
		settings = love.filesystem.read( "video.txt", 50 )
		data = settings:split(":")
		local scaleL,vsyncL,fullscreenL,fsaaL = 1,true,false,0
		for i,v in pairs(data) do
			if i == 1 then scaleL = v end
			if i == 2 then vsyncL = tobool(v) end
			if i == 3 then fullscreenL = tobool(v) end
			if i == 4 then fsaaL = v end
		end
		love.graphics.setMode(600*scaleL, 400*scaleL, fullscreenL, vsyncL, fsaaL)
		scale = scaleL
		print("Loaded video settings.")
	else
		print("Video settings file not found.")
	end
end

function savePlayerSettings(player,r,g,b)
	if love.filesystem.isFile( "player.txt" ) then
		--Guardar
		if player == 1 then
			love.filesystem.write("player.txt", r..":"..g..":"..b..":"..playerColor.s.R..":"..playerColor.s.G..":"..playerColor.s.B,50 )
			playerColor.f.R=r
			playerColor.f.G=g
			playerColor.f.B=b
		elseif player == 2 then
			love.filesystem.write("player.txt", playerColor.f.R..":"..playerColor.f.G..":"..playerColor.f.B..":"..r..":"..g..":"..b,50 )
			playerColor.s.R=r
			playerColor.s.G=g
			playerColor.s.B=b
		end
		print("Saved and updated player settings.")
	else
		print("Player settings file not found.")
	end
end

function loadPlayerSettings()
	if love.filesystem.isFile( "player.txt" ) then
		local string = love.filesystem.read( "player.txt", 50 )
		local playerdata = string:split(":")
		for i,v in pairs(playerdata) do
			if i == 1 then playerColor.f.R = tonumber(v) end
			if i == 2 then playerColor.f.G = tonumber(v) end
			if i == 3 then playerColor.f.B = tonumber(v) end
			if i == 4 then playerColor.s.R = tonumber(v) end
			if i == 5 then playerColor.s.G = tonumber(v) end
			if i == 6 then playerColor.s.B = tonumber(v) end
		end
		print("Loaded player settings.")
	else
		print("Player settings file not found.")
	end
end

--Rob Miracle, String Split
function string:split( inSplitPattern, outResults )

   if not outResults then
      outResults = { }
   end
   local theStart = 1
   local theSplitStart, theSplitEnd = string.find( self, inSplitPattern, theStart )
   while theSplitStart do
      table.insert( outResults, string.sub( self, theStart, theSplitStart-1 ) )
      theStart = theSplitEnd + 1
      theSplitStart, theSplitEnd = string.find( self, inSplitPattern, theStart )
   end
   table.insert( outResults, string.sub( self, theStart ) )
   return outResults
end

function tobool(string)
	if string == "true" or string == "TRUE" then
		return true
	elseif string == "false" or string == "FALSE" then
		return false
	end
end